Description

At Planio we encountered occasional deadlocks caused by the inner lock statement on the query selecting a potentially already

existing identical attachment. Running the query without lock first and locking the found record second solved the problem for us.

To account for the possible failure of the inner lock (i.e. when existing was found but cannot be locked) this patch also adds a rescue

clause that silently ignores such errors. Deduplication did not happen in this case either because the duplicate was removed (then a

retry would be useless) or the database aborted the transaction (deadlock or waited too long for the lock, a retry might work but I'm

not sure it's worth it).

Related issues:

Blocks Redmine - Patch #25215: Re-use existing identical disk files for new a... Closed

Associated revisions

Revision 16541 - 2017-04-13 14:10 - Jean-Philippe Lang

Prevent deadlocks by only locking the exact records we need to have locked (#25590).

Patch by Jens Kraemer.

History

#1 - 2017-04-12 08:54 - Go MAEDA

- Related to Patch #25215: Re-use existing identical disk files for new attachments added

#2 - 2017-04-12 09:53 - Go MAEDA

- Related to deleted (Patch #25215: Re-use existing identical disk files for new attachments)

#3 - 2017-04-12 09:54 - Go MAEDA

- Blocks Patch #25215: Re-use existing identical disk files for new attachments added

#4 - 2017-04-12 11:00 - Go MAEDA

I reopened #25215. Thank you for sharing the patch.

#5 - 2017-04-13 14:10 - Jean-Philippe Lang

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

Committed.
